package org.jboss.security;

package .tmp;

import java.net.Authenticator;
import java.net.PasswordAuthentication;
import java.security.Principal;

public class SecurityAssociationAuthenticator extends Authenticator {
  protected PasswordAuthentication getPasswordAuthentication() {
    SecurityActions sa = SecurityActions.UTIL.getSecurityActions();
    Principal principal = sa.getPrincipal();
    Object credential = sa.getCredential();
    String name = (principal != null) ? principal.getName() : null;
    char[] password = new char[0];
    if (credential != null)
      if (password.getClass().isInstance(credential)) {
        password = (char[])credential;
      } else {
        password = credential.toString().toCharArray();
      }  
    PasswordAuthentication auth = new PasswordAuthentication(name, password);
    return auth;
  }
}
